000010*>
000020 IDENTIFICATION DIVISION.
000030 PROGRAM-ID.   READWRITEBtrieveDemo.
000031 AUTHOR.       AG-TECH Corp.
000032*------------------------------------------
000033* Actian Zen (Btrieve Level)
000034* READ WRITE Demonstration Program
000035* xm NetCOBOL for Windows 
000036* Copyright (c) 2021 by AG-TECH CORP.
000037*------------------------------------------
000041 ENVIRONMENT    DIVISION.
000050  CONFIGURATION  SECTION.
000051  INPUT-OUTPUT SECTION.
000052   FILE-CONTROL.
000053     SELECT file-1 ASSIGN TO "READWRITE_SAMPLEDATA.MKD,BTRV"
000054     ORGANIZATION IS INDEXED
000055     ACCESS MODE RANDOM
000056     RECORD KEY IS mainkey OF record-data.
000057     SELECT file-1-read ASSIGN TO "READWRITE_SAMPLEDATA.MKD,BTRV"
000058     ORGANIZATION IS INDEXED
000059     ACCESS MODE SEQUENTIAL
000060     RECORD KEY IS mainkey OF record-data-read.
000061 DATA DIVISION.
000062 FILE SECTION.
000063 FD file-1.
000064*------------------------------------------
000065*   Btrieve Data File Structure
000066*------------------------------------------
000067 01 record-data.
000068   02 mainkey PIC S9(5).
000069   02 numericdata PIC S9(5).
000070   02 comp3data PIC S9(5) COMP-3.
000071   02 textdata PIC X(50).
000072 FD file-1-read.
000073 01 record-data-read.
000074   02 mainkey PIC S9(5).
000075   02 numericdata PIC S9(5).
000076   02 comp3data PIC S9(5) COMP-3.
000077   02 textdata PIC X(50).
000078 WORKING-STORAGE SECTION.
000082 01 workarea.
000083   02 mainkey PIC S9(5).
000084   02 numericdata PIC S9(5).
000085   02 comp3data PIC S9(5) COMP-3.
000086   02 textdata PIC X(50).
000087 01 WS-A PIC S9(5) VALUE -99.
000088 01 PROCESSING-SWITCH PIC X.
000089   88  END-OF-PROCESSING VALUE "1".
000091 PROCEDURE DIVISION.
000092*> Btrieve t@Cւ̏
000093     OPEN OUTPUT file-1.
000094     PERFORM 200 TIMES
000095       MOVE WS-A TO mainkey OF workarea
000096       MOVE WS-A TO numericdata OF workarea
000097       MOVE WS-A TO comp3data OF workarea
000098       MOVE "eXgTest" TO textdata OF workarea
000099*> NetCOBOL̓`88R\[VA`ւ̕ϊ       
000100       CALL "#DECFJTO88" USING workarea
000101       WRITE record-data FROM workarea
000102       ADD 1 TO WS-A 
000103     END-PERFORM.
000104     CLOSE file-1. 
000111*> Btrieve t@C̓ǂݍ
000112     OPEN INPUT file-1-read.
000113     MOVE -99 TO mainkey OF workarea.
000114*> NetCOBOL̓`88R\[VA`ւ̕ϊ     
000115     CALL "#DECFJTO88" USING workarea.
000116     MOVE mainkey OF workarea TO mainkey OF record-data-read.
000117     START file-1-read.
000118     PERFORM UNTIL END-OF-PROCESSING 
000126       READ file-1-read INTO workarea 
000127       	AT END SET END-OF-PROCESSING TO TRUE
000128       END-READ	
000129*> 88R\[VA`NetCOBOL̓`ւ̕ϊ 
000130       CALL "#DEC88TOFJ" USING workarea 
000131       DISPLAY "mainkey :" mainkey OF workarea
000132       DISPLAY "numericdata :" numericdata OF workarea
000133       DISPLAY "comp3data :" comp3data OF workarea
000134       DISPLAY "textdata :" textdata OF workarea
000135     END-PERFORM.    
000136     CLOSE file-1-read.  
000139   
000140 END PROGRAM READWRITEBtrieveDemo.